{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O'}}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.stores.type=new mj.store({
                data:[{id:'ISG',code:'ISG'},{id:'MSDS',code:'MSDS'},{id:'SOP',code:'SOP'},{id:'TEZGAH AYAR FÖYÜ',code:'TEZGAH AYAR FÖYÜ'},{id:'TEZGAH DDOKÜMANI',code:'TEZGAH DDOKÜMANI'}]
            });
            t.stores.typeG=new mj.store({
                data:[{id:'ISG',code:'ISG'},{id:'MSDS',code:'MSDS'},{id:'SOP',code:'SOP'},{id:'TEZGAH AYAR FÖYÜ',code:'TEZGAH AYAR FÖYÜ'},{id:'TEZGAH DDOKÜMANI',code:'TEZGAH DDOKÜMANI'}]
            });
            const gridConfig = {
                cm: [
                    {header: "{{ 'Document.type'|trans }}", dataIndex: 'type', width: 150,filter:'single', type:'combo',store:t.stores.typeG,alias:'Document',operator:'='},
                    {header: "{{ 'Document.opcode'|trans }}", dataIndex: 'opcode', width: 200,filter:'single',alias:'Document',operator:'%.%'},
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.combo({
                        title: "{{ 'Document.type'|trans }}",
                        placeHolder: "{{ 'Document.type_placeholder'|trans }}",
                        dataIndex: 'type',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '150px',
                        grid: 's6 m4',
                        width : 150,
                        store: t.stores.type
                    }),
                    new mj.form.textField({
                        title: "{{ 'Document.opcode'|trans }}",
                        dataIndex: 'opcode',
                        maxLength: 50,
                        width:200,
                        labelWidth : '150px',
                        grid: 's12 m6'
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t.win.on('afterresize',function(){
                t.southLayout.doLayout();
            });
        },
        _setFormConfig:function(formConfig){
            const t = this;
            t.stores.form = new mj.store({failure:function(a,b){
				//console.log(a);
                //console.log(b);
                t.waitMaskHide();
			}});
            t.stores.form.on('load', t._onFormStoreLoad, t);
    
            t.forms = {};
            t.panel=new mj.panel({
                renderTo : t.tabs.main.form.getBody(),
                border : false,
                buttons:[
                    //{
                    //    alt: mj.lng.glb.save,
                    //    cls: 'btn-sm left',
                    //    iconCls: 'mj-save',
                    //    //invisible: true,
                    //    scope: t,
                    //    handler: t._onButtonFormSubmitClick
                    //},
                    {
                        alt: mj.lng.glb.cancel,
                        cls: 'btn-sm left',
                        iconCls: 'mj-list',
                        //invisible: true,
                        scope: t,
                        handler: t._onButtonFormCancelClick
                    }
                ]               
            });
            t.windowButtons.formSubmit=false;
            t.windowButtons.formCancel=false;
            
            t.layout = new mj.layout({
                renderTo : t.panel.getBody(),
                layout : 'border',
                items : [
                    {
                        region  : 'north',
                        initial : 60,
                        min : 60,
                        max : 60,
                        split: false,
                        collapsible : false,
                        collapsed : false
                    }
                ]
            });
            
            t.southLayout = new mj.layout({
                renderTo : mj.NE(t.layout.getBody('center')),
                layout : 'border',
                items : [
                    {
                        region  : 'west',
                        initial : 280,
                        min : 280,
                        max : 280,
                        split: false,
                        collapsible : false,
                        collapsed : false
                    }
                ]
            });

            t.forms.main = new mj.form(mj.apply({
                renderTo: t.layout.getBody('north'),//t.tabs.main.form.getBody(),
                modulename: t.modulename,
                store: t.stores.form,
                buttonPos:false
            }, formConfig));
            
            t.initDefaultButtons();
            t.buttons.formSubmit = t.panel.buttons[0];
            t.buttons.formCancel = t.panel.buttons[1];

            t.winAddChildRecord = new mj.window({
                renderTo : mj.NE(),
                title : '',
                modal : true,
                width : 400,
                height : 230,
                minWidth : 400,
                minHeight : 230,
                buttons : [
                    {title: mj.lng.glb.exit, handler:function(){t.winAddChildRecord.hide();}},
                    {title: mj.lng.glb.save}
                ]
            });
            
            t.win.addRelated(t.winAddChildRecord);
            
            t.forms.childRecords = new mj.form({
                renderTo : t.winAddChildRecord.getBody(),
                store : new mj.store({}),
                buttonPos:false
            });

            t.grids.groups = new mj.grid({
                win: t.win,
                renderTo: t.southLayout.getBody('west'),
                store: [],
                pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent: true,
                cm : [
                    {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                   {header: "{{ 'Document.opname'|trans }}", dataIndex: 'opname', width: 250},
                    {header: '', width: 5,hide:true}
                ]
            });
            t.grids.groups.on('rowclick',function(g,s){
                var d = g.selectedRow.data;
                if(d._details&&d._details.length>0){
                    t.grids.details.store.data = d._details;
                }else{
                    t.grids.details.store.data=[];
                }
                t.grids.details.load();
                t.buttons['addBtndetails'].setEnable();
                //console.log('1')
            });
            t.grids.details = new mj.grid({
                win: t.win,
                renderTo: t.southLayout.getBody('center'),
                store: [],
                pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent: true,
                cm : [
                    {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                    {header: "{{ 'Document.path'|trans }}", dataIndex: 'path', width: 350},
                    {header: "{{ 'Document.currentversion'|trans }}", dataIndex: 'currentversion', width: 60,align:'right'},
                    {header: "{{ 'Document.lastupdate'|trans }}", dataIndex: 'lastupdate', width: 120},
                    {header: "{{ 'Document.islot'|trans }}", dataIndex: 'islot', width: 40,renderer:mj.renderer.check()},
                    {header: '', width: 5,hide:true}
                ]
            });

            for(var item in t.grids){
                if(item!='main'){
                    t.buttons['addBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnAddTable',alt:mj.lng.glb.add, iconCls : 'mj-add', disabled: true, handler : t.addChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'add'}});
                    t.buttons['editBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnEdit',alt:mj.lng.glb.edit,iconCls :'mj-edit', disabled:true, handler:t.editChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'edit'}});
                    t.buttons['deleteBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnDeleteTable',alt:mj.lng.glb.del, iconCls : 'mj-delete', disabled: true, handler:t.deleteChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item}});
                    t.grids[item].on('rowclick',function(g,s){
                        t.buttons['editBtn'+this].setEnable();
                        t.buttons['deleteBtn'+this].setEnable();
                    },item);
                    t.grids[item].on('rowdblclick',function(g,s){
                        this.handler.call(this.scope);
                    },t.buttons['editBtn'+item]);
                    t.grids[item].store.on('load',function(){
                        t.btnChildDisabler(this);
                        t.buttons['addBtngroups'].setEnable();
                        // if(item==='details'){
                        //     t.buttons['addBtndetails'].setEnable();
                        //     console.log('2')
                        // }
                    },item);
                    t.grids[item].load();
                }
            }

            t.forms.main.items[3].on('blur',function(){
                var _type=t.forms.main.items[2].getValue();
                var _opcode=t.forms.main.items[3].getValue();
                if(_type!==''&&_opcode!==''){
                    var f = t.forms.main;
                    var routeName = f.modulename + '-load';
                    var route = Routing.getRoute(routeName);
                    var url = Routing.generate(routeName, {'type':_type,'opcode':_opcode});
                    var data = f.getValue();
                    data.menuId = t.id;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t.grids.groups.store.data=[];
                        t.grids.details.store.data=[];
                        t.grids.groups.load();
                        t.grids.details.load();
                        $.ajax({
                            url: url,
                            method: "POST",
                            data: JSON.stringify(data),
                            dataType: 'json',
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            success: function(data, textStatus, xhr) {
                                if(data["Document"]){
                                    t.forms.main.store.preloaded = true;
                                    //t.forms.main.store.data = data.Document.records;
                                    t.forms.main.store.data = data;
                                    t.forms.main.store.load();
                                }
                                t.waitMaskHide();
                            },
                            error: function(xhr, textStatus, errorThrown) {
                                t.waitMaskHide();
                                if(xhr.responseJSON&&xhr.responseJSON.message){
                                    mj.message({
                                        title: mj.lng.glb.error,
                                        msg: xhr.responseJSON.message,
                                        type: "error",
                                        html: true
                                    });
                                }
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                }
            });
        },
        formCreator : function(g,i,m){
            var t=this;
            t.forms.childRecords.removeAll();
            switch (i){
                case 'details':
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'id',
                            labelWidth : '120px',
                            itemStyle : 'padding-top:5px;',
                            hidden:true,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "type",
                            dataIndex : 'type',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : t.forms.main.items[2].getValue()
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "opcode",
                            dataIndex : 'opcode',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : t.forms.main.items[3].getValue()
                        })
                    );
                    var opname='';
                    if(t.grids.groups&&t.grids.groups.selectedRow&&t.grids.groups.selectedRow.data&&t.grids.groups.selectedRow.data.opname){
                        opname=t.grids.groups.selectedRow.data.opname;
                    }
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "opname",
                            dataIndex : 'opname',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : opname
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'Document.currentversion'|trans }}",
                            dataIndex : 'currentversion',
                            labelWidth : '120px',
                            itemStyle : 'padding-top:5px;',
                            width : 50,
                            maxLength: 3
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.checkBox({
                            title: "{{ 'Document.islot'|trans }}",
                            id: 'islot',
                            dataIndex: 'islot',
                            //itemStyle: 'padding:0 35px 0 0;float:left;',
                            labelWidth : '60px',
                            grid: 'none',
                            right:true
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.dateField({
                            title: "{{ 'Document.lastupdate'|trans }}",
                            dataIndex: 'lastupdate',
                            labelWidth : '120px',
                            notEmpty: true,
                            width:80,
                            grid: 's4 m2'
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title: "{{ 'Document.description'|trans }}",
                            dataIndex : 'description',
                            labelWidth : '120px',
                            itemStyle : 'padding-top:5px;',
                            width : 240,
                            maxLength: 250
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.fileInput({
                            title : "{{ 'Document.path'|trans }}",
                            dataIndex : 'path',
                            maxFile : 1,
                            labelWidth : '120px',
                            accept : '.jpg',
                            width : 150
                        })
                    );
                    break;	
                case 'groups':
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'id',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            hidden:true,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "opcode",
                            dataIndex : 'opcode',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : t.forms.main.items[3].getValue()
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "{{ 'Document.opname'|trans }}",
                            dataIndex : 'opname',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            notEmpty : true
                        })
                    );
            }
            if(m == 'edit'){
                t.forms.childRecords.store.data = g.selectedRow.data;
                t.forms.childRecords.load();
            }
        },
        saveChildRecord : function(){
            var t = this.scope, g = this.grid, m = this.mode, item = this.item, _err = false;
            var d =  t.forms.childRecords.getValue();
            if(item=='groups'){
                //if(typeof d.code=='undefined'||d.code==''){
                //    _err = true;
                //    t.forms.childRecords.items[2].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
                if(!_err){
                    if(m == 'edit'){
                        d._details = g.store.data[g.selectedRow.index]._details;
                        g.store.data[g.selectedRow.index] = d;
                    }else{
                        d._details = [];
                        g.store.data.push(d);
                    }
                    g.load();
                    t.winAddChildRecord.hide();
                }
            }else{
                //t.forms.childRecords.items[1].clearInvalid();
                //if(typeof d.leafId=='undefined'||d.leafId==''){
                //    _err = true;
                //    t.forms.childRecords.items[1].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
                //if((typeof d.leafmask=='undefined'||d.leafmask==''||parseInt("0"+d.leafmask)==0)&&!_err){
                //    _err = true;
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
                if(!_err){
                    var data = new FormData(t.forms.childRecords.form[0]);
                    data.append("formData",JSON.stringify(d));
                    data.append("menuId",t.id);
                    data.append("groups",JSON.stringify(t.grids.groups.store.data));
                    var routeName = t.forms.main.modulename + '-upload';
                    var route = Routing.getRoute(routeName);
                    var url = Routing.generate(routeName, {});
                    t.winAddChildRecord.waitMask.show();
                    t.winAddChildRecord.buttons[0].setDisable();
                    t.winAddChildRecord.buttons[1].setDisable();
                    $.ajax({
                        type: "POST",
                        enctype: 'multipart/form-data',
                        url: url,
                        data: data,
                        processData: false,
                        contentType: false,
                        cache: false,
                        timeout: 600000,
                        success: function (data) {
                            t.winAddChildRecord.waitMask.hide();
                            t.winAddChildRecord.buttons[0].setEnable();
                            t.winAddChildRecord.buttons[1].setEnable();
                            if(m == 'edit'){
                                data._details = g.store.data[g.selectedRow.index]._details;
                                g.store.data[g.selectedRow.index] = data;
                            }else{
                                g.store.data.push(data);
                                t.grids.groups.selectedRow.data._details=g.store.data;
                            }
                            g.load();
                            t.winAddChildRecord.hide();
                            t.buttons['addBtndetails'].setEnable();
                            //console.log('3')
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                            //console.log(jqXHR, textStatus, errorThrown)
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                type: "error",
                                html: true
                            });
                            t.winAddChildRecord.waitMask.hide();
                            t.winAddChildRecord.buttons[0].setEnable();
                            t.winAddChildRecord.buttons[1].setEnable();
                            t.buttons['addBtndetails'].setEnable();
                            //console.log('4')
                        }
                    });
                }
            }
            
        },
        windowSetHandler : function(g,i,m){
            var t=this;
            t.winAddChildRecord.setTitle(m=='add'?mj.lng.glb.addRecord:mj.lng.glb.editRecord);
            t.winAddChildRecord.buttons[1].setHandler(t.saveChildRecord,{scope:t,grid:g,mode:m,item:i});
            t.formCreator(g,i,m);
        },        
        addChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            var cat=t.forms.main.items[2].getValue();
            if(cat!==''&&cat!==null){
                if(item=='groups'){
                    t.grids.groups.clearSelectedRow();
                    t.grids.details.store.data = [];
                    t.grids.details.load();
                    t.buttons['addBtndetails'].setDisable();
                    //console.log('5')
                }
                t.windowSetHandler(g,item,m);
                t.winAddChildRecord.show();
            }else{
                t.forms.main.items[2].focus();
            }
        },
        editChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            t.windowSetHandler(g,item,m);
            t.winAddChildRecord.show();
        },
        deleteChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            new mj.message({
                title:mj.lng.glb.onay,
                modal : true,
                msg:mj.lng.glb.delQuestion,
                buttons:['NO','YES'],
                cb:function(el,btn){
                    if(btn=='YES'){
                        var routeName = t.modulename + '-child-del';
                        var route = Routing.getRoute(routeName);
						var url = Routing.generate(routeName, {});
                        var selectedRow=g.store.data[g.selectedRow.index];
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
							t.waitMaskShow();
							var data = {"menuId": t.id,"data":JSON.stringify(selectedRow),"item":item};
							$.ajax({
								url: url,
								method: "POST",
								dataType: 'json',
								data: JSON.stringify(data),
								headers: { 
									"Content-Type": "application/json",
									"X-HTTP-Method-Override": route.methods[0] 
								},
								success: function(data, textStatus, jqXHR) {
									t.waitMaskHide();
                                    if(typeof g.store.data[g.selectedRow.index]._details=='object'&&item=='groups'){
                                        t.grids.details.store.data = [];
                                        t.grids.details.load();
                                        t.buttons['addBtndetails'].setDisable();
                                        //console.log('6')
                                    }
                                    g.store.data.remove(g.store.data[g.selectedRow.index]);
                                    g.load();
                                    if(item==='details'){
                                        t.buttons['addBtndetails'].setEnable();
                                        //console.log('7')
                                    }
								},
								error: function(jqXHR, textStatus, errorThrown) {
									t.waitMaskHide();
									mj.message({
										title: mj.lng.glb.error,
										msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
										type: "error",
										html: true
									});
								},
								complete: function(jqXHR, textStatus) {
									//t.waitMaskHide();
								}
							});
						}
                    }
                    el.window.close();
                }
            });
        },
        btnChildDisabler:function(item){
            var btns = this.buttons;
            if(btns['addBtn'+item]&&typeof btns['addBtn'+item].setDisable == 'function')
                btns['addBtn'+item].setDisable();
            if(btns['editBtn'+item]&&typeof btns['editBtn'+item].setDisable == 'function')
                btns['editBtn'+item].setDisable();
            if(btns['deleteBtn'+item]&&typeof btns['deleteBtn'+item].setDisable == 'function')
                btns['deleteBtn'+item].setDisable();
        },
        _onButtonAddClick:function(){
            var t=this;
            t.grids.groups.store.data=[];
            t.grids.groups.load();
            t.grids.details.store.data = [];
            t.grids.details.load();
            t.newRecord();
        },
        _onFormStoreLoad:function(store){
            var t=this;
            if(store.recordCount>0){
                store.data=store.data[0];
                t.forms.main.loadForm();
                t.grids.groups.store.data=store.data._groups;
                t.grids.groups.load();
                t.grids.details.store.data = [];
                t.grids.details.load();
                t.activateTabForm();
                t.waitMaskHide();
            }
        },
        editData:function(data){
            var t=this;
            var routeName = t.modulename + '-show';
            var route = Routing.getRoute(routeName);
            var data = {
                'id': data.id,
                'menuId': t.id
            };
            var url = Routing.generate(routeName, data);
            this.forms.main.store.modulename=t.modulename;
            this.forms.main.store.url=url;
            this.forms.main.store.method= route.methods[0];
            this.forms.main.store.load();
            t.waitMaskShow();
        },
        save: function() {
            return;
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
